



$(document).ready(function($){


    // repairOfApartmentsGallery
    repairOfApartmentsGallery( $('.repair-of-apartments-gallery') );
    function repairOfApartmentsGallery( box ) {
        if ( !box.length ) return;

        var $sliderBox = box.find('.roag-slider'),
            $sliderBoxOverlay = $sliderBox.find('.overlay'),
            $sliderBoxDraggableDiv = $sliderBoxOverlay.find('.draggable'),
            $sliderBoxDecorBg = $sliderBox.find('.rs-decorate-bg'),
            $sliderThumbsWrap = box.find('.roag-slider-thumbs'),
            $sliderThumbs = $sliderThumbsWrap.find('ul').children(),
            $sliderThumbShowMoreBtn = $sliderThumbsWrap.find('.rgst-show-more-button');

        // добавляем классы для отключания (переобновляемой анимации после аякса для 1го запуска) и запуска определенного вида анимации именно для 1го запуска
        $sliderBox.addClass('noAnimation').addClass('runAnimationOnLoad');

        // инициализация слайдера
        var $sliderExemplar = new Myslider($sliderBox, {
            visibleItems: 1,
            autoStart: false,
            stopOnHover: true,
            playOnMouseLeave: false,
            gpu: false,
            cssTranslateX: true,
            speed: 350,
            waitTime: 0,
            responsive: true,
            viewportWidth: false,
            easingName: 'easeInOut',
            beforeSlideMoved: true,
            afterSlideMoved: true,
            beforeSlideMovedFunction: function(slider){
                updateNames( $(slider[0]) );
            },
            afterSlideMovedFunction: function(slider){
                updateNames( $(slider[0]) );
            },
            itemsWidth: 528,
            itemsHeight: 350,
            toggleClassOnHover: true,
            dots: true,
            touchActions: true
        });


        // первый запуск (по умлочанию) получения картинок через аякс
        getImages( $sliderThumbs.eq(0), $sliderThumbs.eq(0).data('id') );


        var transEnd = (function(){
            var d = document.createElement('div');
            var transEndEventNames = {
                WebkitTransition : 'webkitTransitionEnd',
                MozTransition    : 'transitionend',
                OTransition      : 'oTransitionEnd otransitionend',
                transition       : 'transitionend'
            };
            for( var name in transEndEventNames ){
                if( d.style[name] !== undefined ) return transEndEventNames[name];
            }
            return false;
        })();


        // универсальня ф-я запуска чего-либо после окончания CSS-анимации блока
        function transitionEnd( $elem, fn ){
            $elem.one( transEnd, fn );
        }

        // применим слушатели событий для каждого плиточного превью и анимируем
        transitionEnd($sliderBox, function () {
            $sliderThumbs.each(function (i) {
                var $this = $(this);
                $this.find('img').imagesLoaded({
                        background: false
                    }, function(){
                        setTimeout(function () {
                            $this.removeClass('hidden');
                        }, 650 * (i+1) );
                    }
                );
            }).on('click', updGetImages);
        });

        var $BoxTitle = box.find('.roag-title');

        // ф-я запуска анимации заголовка (после окончания анимации появления плиток в превью)
        transitionEnd($sliderThumbs.eq(2), function () {
            $BoxTitle.removeClass('hidden');
            $sliderThumbShowMoreBtn.removeClass('hidden');
        });


        // ф-я обновления названия для текущего слайда
        function updateNames(slider){
            slider.find('.rs-description').text(slider.find('.item:first').children('img').attr('alt') );
        }


        // ф-я получения картинок через аякс
        function getImages(elem, id){
            if ( elem.hasClass('disabled') || elem.hasClass('active') ) return;

            $.ajax({
                type: 'post',
                data: 'id='+id+'', // ID превью
                url: 'php/test.php', // ваш PHP должен возвращать JSON (пример ответа сервера ниже)
                dataType: 'json',
                success: function(data){
                    if (data) {

                        /*// пример ответа сервера ( получаемые данные - JSON )
                        [{
                            response: 'ok',
                            imgData: [{
                                    url: 'img/slider-image-0.jpg',
                                    name: 'Name 0'
                                }, {
                                    url: 'img/slider-image-0--1.jpg',
                                    name: 'Name 1'
                                }, {
                                    url: 'img/slider-image-0--2.jpg',
                                    name: 'Name 2'
                             }]
                        }];*/

                        // тест на примере ниже
                        data = [{
                            response: 'ok',
                            imgData: [{
                                url: 'img/slider-image-'+id+'.jpg',
                                name: 'Image ID='+id+' Name 0'
                            }, {
                                url: 'img/slider-image-'+id+'--1.jpg',
                                name: 'Image ID='+id+' Name 1'
                            }, {
                                url: 'img/slider-image-'+id+'--2.jpg',
                                name: 'Image ID='+id+' Name 2'
                            }]
                        }];

                        // ok
                        if ( data[0].response === 'ok' ) {
                            refreshSlider($sliderBox, $sliderExemplar, data);
                            $sliderThumbsWrap.find('ul').children().removeClass('active');
                            elem.addClass('active');
                        }
                        // ошибка
                        if ( data[0].response === 'error' ) alert('Ошибка получения данных, id= '+id);
                    }
                    else alert('Нет данных, id= '+id);
                },
                error: function(){
                    alert('Ошибка отправки данных, id= '+id);
                }
            });

        }


        // ф-я рефреша запуска получения картинок через аякс при событии клика на блок блока превью (полученного в аксе после показа болшего кол-ва)
        function updGetImages() {
            getImages( $(this), $(this).data('id') );
        }

        function refreshSlider($slider, $sliderExemplar, data) {
            // блокируем клик по плиткам в преью
            $sliderThumbsWrap.find('ul').children().addClass('disabled');

            // если мы только что открыли страницу то не запускаем рефрешы после анимации
            if ( $slider.hasClass('noAnimation') ) {
                updateSilderBox();
                updateDecImgBox();
            }
            // если кликаем на блоки то происходит последовательный запуск событий после окончания анимации предыдущего события
            else {
                $sliderBoxOverlay.addClass('hidden');
                transitionEnd($sliderBoxOverlay, updateSilderBox);
                transitionEnd($sliderBoxDecorBg, updateDecImgBox)
            }

            // ф-я обновления слайдера
            function updateSilderBox(){

                // обнавляем структуру внутри слайдера
                $sliderBoxDraggableDiv.empty();
                for (var i = 0; i < data[0].imgData.length; i++){
                    $sliderBoxDraggableDiv.append('<a class="item" rel="gallery" href="'+data[0].imgData[i].url+'" title="'+data[0].imgData[i].name+'"><img src="'+data[0].imgData[i].url+'" alt="'+data[0].imgData[i].name+'"></a>');
                }

                // рефреш слайдера и слайдов в нем
                $sliderExemplar.sizeUpdate();
                updateNames ($slider);

                var $sliderBoxItems = $sliderBoxDraggableDiv.find('.item');

                // проверяем загружены ли картинки слайдов после чего анимируем
                $sliderBoxItems.each(function () {
                    var $this = $(this);
                    $this.find('img').imagesLoaded({
                            background: false
                        }, function(){
                            $this.addClass('loaded').fancybox();
                            if ( $sliderBoxItems.filter('.loaded').length === data[0].imgData.length ) {
                                $sliderBoxOverlay.removeClass('hidden');
                            }
                        }
                    );

                });

                // скрываем блурный блок под слайером
                $sliderBoxDecorBg.addClass('hidden');
            }


            // ф-я обновления блурного изборажения за слайдером
            function updateDecImgBox(){
                $sliderBoxDecorBg.children().attr('style', 'background-image: url('+data[0].imgData[0].url+')').imagesLoaded({
                        background: true
                    }, function(){
                        $sliderBoxDecorBg.removeClass('hidden');
                        $slider.removeClass('noAnimation');
                    }
                );
                setTimeout(function () {
                    $sliderThumbsWrap.find('ul').children('li').removeClass('disabled');
                }, 1000);
            }

        }


        // клик по кнопке показа большего кол-ва
        $sliderThumbShowMoreBtn.click(function () {
            var $this = $(this),
                i = 0;

            if ( $this.hasClass('disabled') ) return;

            $.ajax({
                type: 'post',
                data: 'offset='+i+'', // кол-во кликов
                /*url: 'php/test.php', // ваш PHP должен возвращать html вида в тесте ниже*/
                url: 'ajax/repair-of-apartments-gallery-rows.html', // тест
                dataType: 'html',
                success: function(data){
                    if (data) {
                        i++;
                        // макс кол-во кликов для показа большего кол-ва (тест >= 1)
                        if ( i >= 1 ) $this.addClass('disabled').text('Показаны все варианты');
                        else $this.removeClass('disabled').text('Больше наших ремонтов');
                        // апдейт структуры превью
                        $sliderThumbsWrap.find('ul').append( data ).children().off('click', updGetImages).on('click', updGetImages);
                    }
                    else alert('Нет данных для получения превью');
                },
                error: function(){
                    alert('Ошибка отправки данных для получения превью');
                }
            });
        });


        var wrapper = box.find('.roag-wrapper.first'),
            col2 = wrapper.find('.roag-wrap-column:last');

        // меняем блоки местами при репонсиве
        $(window).on('load resize', function () {
            if ( $(this).width() <= 768 && window.matchMedia('(orientation: portrait)').matches) wrapper.prepend(col2);
            else wrapper.append(col2);
        });


    }






});



